' 
' SIDcog TrainSound 
' 

CON _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000    
    freqAdjust  = 0.35                       ' Adjust the relative frequency of both 1 and 2
 
    freq1       = trunc(12250.0*freqAdjust)   ' Whistle frecuency 1 = G                              
    freq2       = trunc(15435.0*freqAdjust)   ' Whistle frecuency 2 = B
    freq3       = trunc(18350.0*freqAdjust)   ' Whistle frecuency 3 = D                            
    freq4       = trunc(20600.0*freqAdjust)   ' Whistle frecuency 4 = E
    freq5       = trunc(24500.0*freqAdjust)   ' Whistle frecuency 5 = G
        
    whistleWait = 8191                       ' Wait between whistles, try different values, 255, 1023, 2047, 4097, 8191
    updateRate  = 120                        ' Tuff tuff speed
    
OBJ
  SID1 : "SIDCog"
  SID2 : "SIDCog"
  
PUB Main | i, whistle, frame, finetune

  SID1.start(10,0)                         'Start the emulated SID and output sound on pin 10 and 11 
  waitcnt(cnt+100000)
  SID2.start(11,0)
  SID1.setVolume(15)                       'Set volume to max
  SID2.setVolume(15)

  SID2.setCutoff(300)
  SID2.setFilterMask(true,true,true)
  SID2.setFilterType(false,true,true)
        
  repeat
    waitcnt(cnt+(clkfreq/updateRate))
    frame++

    ' This is for controlling the whistle
    if (frame&whistleWait) == 220 or (frame&whistleWait) == 280 
      whistle := true
      finetune := 0
    if (frame&whistleWait) == 260  or (frame&whistleWait) == 400
      whistle := false

    'Tuff tuff sound
    if (frame&15)==7 and not whistle  
      SID1.play(0,24000+((?i)&511),SID1#NOISE,3,4,6,9)
    if (frame&15) == 12 and not whistle     
      SID1.noteOff(0)

    'Whistle sound
    if whistle
      finetune:=(finetune+10)<#150
      SID1.setResonance(10)
      SID1.setCutoff(370)
      SID1.setFilterMask(true,true,true)
      SID1.setFilterType(true,true,true)  
      SID1.play(0,18_000,SID1#NOISE,1,1,2,5) 
      SID1.play(1,freq1+finetune,SID1#TRIANGLE,1,8,6,11) 
      SID1.play(2,freq2+finetune,SID1#TRIANGLE,1,8,6,11) 
      SID2.play(0,freq3+finetune,SID1#TRIANGLE,1,8,6,11) 
      SID2.play(1,freq4+finetune,SID1#TRIANGLE,1,8,6,11) 
      SID2.play(2,freq5+finetune,SID1#TRIANGLE,1,8,6,11) 
    else
      finetune:=(finetune-18)#>120
      SID1.setResonance(15)
      SID1.setCutoff(150)  
      SID1.setFilterMask(true,false,false) 
      SID1.setFilterType(true,true,false) 
      SID1.setFreq(1,freq1+finetune) 
      SID1.setFreq(2,freq2+finetune) 
      SID2.setFreq(0,freq3+finetune)
      SID2.setFreq(1,freq4+finetune) 
      SID2.setFreq(2,freq5+finetune)
      SID1.noteOff(1)
      SID1.noteOff(2)
      SID2.noteOff(0)
      SID2.noteOff(1)
      SID2.noteOff(2)
                    